Subject: Re: BCM4313 & brcmsmac & 3.12: only semi-working?

From: Arend van Spriel <[email-masked]>
Date: Tue, 26 Aug 2014 23:37:30 +0200

On 08/26/14 18:15, Michael Tokarev wrote:
> 26.08.2014 18:56, Arend van Spriel wrote:
>> On 08/26/14 07:13, Michael Tokarev wrote:
> []
>>> So, I'm curious -- why this driver is found in regular section of kernel?
>>> It looks like it should be in staging at least, or better yet, in a new section
>>> titled "toy drivers" or something like this.  Does it work for any device at
>>> all?
>>
>> Hi Michael,
>>
>> Thanks for your encouraging suggestions.
>
> You might be a good politician :)  These are blames, quite strong...
>
> Seriously. As you revisited this thread, I had quite some issues and
> money loss after all this, -- after initially especially choosing a
> model with a supported wifi card which turned out to be non-working,
> which I tried to fix by buying a new wifi NIC (which didn't work
> thanks to Lenovo), and which I finally broke due to usb wifi dongle
> I used.
>
> But that's all "poetry", the main source of my blames is you reaction -
> your first reply was really ecoraging, I hoped we can have some solution
> together (I have strong programming background, just not as good with
> kernel and drivers as you).  But after your single reply, you never
> spoke again until now.  That's 8 months.  _That_ is where my frustration
> comes from.

Well, sorry about that. I did see the other messages fly by and noticed 
you were using the wl driver so assumed you were fine with that. 
Admittedly the brcmsmac got very little attention as all our resources 
were put on brcmfmac.

> And the actual facts are true - by now I have had 2 entirely different
> devices (my original laptop which is now thrown away and another, given
> by me by a friend because I needed something) - I dunno if that's
> exactly the same wifi card or not (lspci output looks similar, and
> this one is also bt/wifi combo), but they both doesn't work in a
> quite similar way.  So, the driver doesn't work with 2 out of 2 devices
> which I've seen.  Not a good statistics generally, but that's 100%
> "hit" ratio for me.  So I really am curious if this driver works at
> all.
>
>>     I revisited the threads you referred to. In the boardflags it shows you
>> have a bt+wifi card. It could be that is an issue. The brcmsmac supports other
>> devices, ie. bcm43224/5 and the bcm4313 comes in a number of varieties.
>>  From what you tell here it seems you have trouble in rx path so I will look
>> into that area if there is any specifically done for your variant of the bcm4313.
>
> I tested this "new" laptop with 3.16 kernel just briefly.  I may try more
> complete analysis.  I can participate with the debugging/dumping (I already
> mentioned my strong programming background - but I'm really not into drivers
> and hardware internals).  So, basically, I'm all yours ;)  Not that I really
> need this driver anymore (since I will avoid these cards like a plague, for
> obvious reasons :), but I want to have some good outcome out of all this
> story :)

Ok. Let's put frustration aside and make an effort. So could you make a 
trace using trace-cmd utility. The log can get quite big. The brcmsmac 
driver needs to be built with CONFIG_BRCM_TRACING enabled. Please 
execute the following commands (assuming you use ubuntu with 
network-manager):

$ sudo stop network-manager
$ sudo insmod brcmfmac.ko
$ sudo trace-cmd record -e brcmsmac:*

In another terminal:

$ sudo start network-manager

The trace-cmd must be stopped using ctrl-c.

Regards,
Arend